Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 2291)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 2292)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
+! includes two more prognostic equations for cloud drop concentration (nc)  
+! and cloud water content (qc). 
+! 
+! 2277 2017-06-12 10:47:51Z kanani
 ! Removed unused variable sums_up_fraction_l
 ! 
@@ -560,5 +565,4 @@
 
           IF ( cloud_physics )  THEN
-
 !
 !--          Liquid water content
@@ -568,4 +572,14 @@
              ALLOCATE ( ql_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 #endif
+
+!
+!--          3D-cloud water content
+             IF ( .NOT. microphysics_morrison )  THEN
+#if defined( __nopointer )
+                ALLOCATE( qc(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+#else
+                ALLOCATE( qc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+#endif
+             ENDIF
 !
 !--          Precipitation amount and rate (only needed if output is switched)
@@ -574,13 +588,26 @@
 
 !
-!--          3D-cloud water content
-#if defined( __nopointer )
-             ALLOCATE( qc(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-#else
-             ALLOCATE( qc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-#endif
-!
 !--          3d-precipitation rate
              ALLOCATE( prr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+
+             IF ( microphysics_morrison )  THEN
+!
+!--             3D-cloud drop water content, cloud drop concentration arrays
+#if defined( __nopointer )
+                ALLOCATE( nc(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                &
+                          nc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                          qc(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                &
+                          qc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                          tnc_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) 
+                          tqc_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+#else
+                ALLOCATE( nc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                          nc_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                          nc_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                          qc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                          qc_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                          qc_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+#endif
+             ENDIF
 
              IF ( microphysics_seifert )  THEN
@@ -880,5 +907,11 @@
           IF ( cloud_physics )  THEN
              ql => ql_1
-             qc => qc_1
+             IF ( .NOT. microphysics_morrison )  THEN
+                qc => qc_1
+             ENDIF
+             IF ( microphysics_morrison )  THEN
+                qc => qc_1;  qc_p  => qc_2;  tqc_m  => qc_3
+                nc => nc_1;  nc_p  => nc_2;  tnc_m  => nc_3
+             ENDIF
              IF ( microphysics_seifert )  THEN
                 qr => qr_1;  qr_p  => qr_2;  tqr_m  => qr_3
@@ -979,4 +1012,12 @@
                 ENDDO
              ENDDO
+             IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      qc(:,j,i) = 0.0_wp
+                      nc(:,j,i) = 0.0_wp
+                   ENDDO
+                ENDDO
+             ENDIF
              IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
                 DO  i = nxlg, nxrg
@@ -986,7 +1027,7 @@
                    ENDDO
                 ENDDO
-
              ENDIF
           ENDIF
+
           IF ( passive_scalar )  THEN
              DO  i = nxlg, nxrg
@@ -1107,6 +1148,14 @@
                 ENDDO
              ENDDO
+             IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      qc(:,j,i) = 0.0_wp
+                      nc(:,j,i) = 0.0_wp
+                   ENDDO
+                ENDDO
+             ENDIF
+
              IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
@@ -1115,6 +1164,6 @@
                    ENDDO
                 ENDDO
-
              ENDIF
+
           ENDIF
           
@@ -1319,4 +1368,10 @@
           tq_m = 0.0_wp
           q_p = q
+          IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+             tqc_m = 0.0_wp
+             qc_p  = qc
+             tnc_m = 0.0_wp
+             nc_p  = nc
+          ENDIF
           IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
              tqr_m = 0.0_wp
@@ -1532,4 +1587,8 @@
        IF ( humidity )  THEN
           q_p = q
+          IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+             qc_p = qc
+             nc_p = nc
+          ENDIF
           IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
              qr_p = qr
@@ -1547,4 +1606,8 @@
        IF ( humidity )  THEN
           tq_m = 0.0_wp
+          IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
+             tqc_m = 0.0_wp
+             tnc_m = 0.0_wp
+          ENDIF
           IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
              tqr_m = 0.0_wp
Index: /palm/trunk/SOURCE/init_masks.f90
===================================================================
--- /palm/trunk/SOURCE/init_masks.f90	(revision 2291)
+++ /palm/trunk/SOURCE/init_masks.f90	(revision 2292)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! Implementation of new microphysic scheme: cloud_scheme = 'morrison' 
+! includes two more prognostic equations for cloud drop concentration (nc)  
+! and cloud water content (qc). 
+! 
+! 2271 2017-06-09 12:34:55Z sward
 ! Changed error message
 ! 
@@ -115,5 +120,6 @@
                mask_x_loop, mask_xyz_dimension, mask_y, mask_y_loop, mask_z,   &
                mask_z_loop, max_masks,  message_string, mid,                   &
-               microphysics_seifert, passive_scalar, ocean
+               microphysics_morrison, microphysics_seifert, passive_scalar,    &
+               ocean
 
     USE grid_variables,                                                        &
@@ -278,4 +284,16 @@
                 unit = 'K'
 
+             CASE ( 'nc' )
+                IF ( .NOT. cloud_physics )  THEN
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ), &
+                        '" requires cloud_physics = .TRUE.'
+                   CALL message( 'init_masks', 'PA0108', 1, 2, 0, 6, 0 )
+                 ELSEIF ( .NOT. microphysics_morrison ) THEN
+                   message_string = 'output of "' // TRIM( var ) // '" requi' //  &
+                         'res  = morrison'
+                   CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
+                ENDIF
+                unit = '1/m3'
+
              CASE ( 'nr' )
                 IF ( .NOT. cloud_physics )  THEN
